using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WindowsApplication4
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.treeView1.Nodes.Clear();

            MyNode nd;
            for (int i = 0; i < 15; i++)
            {
                nd = new MyNode();
                if (i % 2 == 0)
                {
                    nd.Tag = "Pari";
                }
                else
                {
                    nd.Tag = "Dispari";
                }
                nd.Text = "Nodo " + i.ToString();
                this.treeView1.Nodes.Add(nd);
            }
        }

        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {
            try
            {
                //Rimuovo eventuali vecchi controlli dal panel2
                this.splitContainer1.Panel2.Controls.Clear();

                //Determino il tipo di userControl da caricare
                if (e.Node.Tag.ToString().Equals("Pari", StringComparison.InvariantCultureIgnoreCase))
                {
                    //UserControl Pari
                    //Controllo se la property relativa all'usercontrol  valorizzata o nulla
                    if (((MyNode)e.Node).CTRLRelated == null)
                    {
                        //Nulla
                        UCPari ucp = new UCPari();
                        ucp.Location = new Point(0, 0);
                        ucp.Dock = DockStyle.Fill;
                        ((MyNode)e.Node).CTRLRelated = ucp;
                        this.splitContainer1.Panel2.Controls.Add(ucp);
                    }
                    else
                    {
                        this.splitContainer1.Panel2.Controls.Add(((MyNode)e.Node).CTRLRelated);
                    }
                }
                else
                {
                    //UserControl Dispari
                    //Controllo se la property relativa all'usercontrol  valorizzata o nulla
                    if (((MyNode)e.Node).CTRLRelated == null)
                    {
                        //Nulla
                        UCDispari ucd = new UCDispari();
                        ucd.Location = new Point(0, 0);
                        ucd.Dock = DockStyle.Fill;
                        ((MyNode)e.Node).CTRLRelated = ucd;
                        this.splitContainer1.Panel2.Controls.Add(ucd);
                    }
                    else
                    {
                        this.splitContainer1.Panel2.Controls.Add(((MyNode)e.Node).CTRLRelated);
                    }    
                }
            }
            catch (Exception)
            {
            }
        }
    }

    public class MyNode : TreeNode
    {
        public MyNode()
        {
        }

        UserControl _CTRLRelated = null;
        public UserControl CTRLRelated
        {
            get { return _CTRLRelated; }
            set { _CTRLRelated = value; }
        }
    }
}